/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppKeyRegistrationConfig extends cdktf.TerraformMetaArguments {
    /**
    * The Application Key ID to register.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.68.0/docs/resources/app_key_registration#id AppKeyRegistration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.68.0/docs/resources/app_key_registration datadog_app_key_registration}
*/
export declare class AppKeyRegistration extends cdktf.TerraformResource {
    static readonly tfResourceType = "datadog_app_key_registration";
    /**
    * Generates CDKTF code for importing a AppKeyRegistration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppKeyRegistration to import
    * @param importFromId The id of the existing AppKeyRegistration that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.68.0/docs/resources/app_key_registration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppKeyRegistration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.68.0/docs/resources/app_key_registration datadog_app_key_registration} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppKeyRegistrationConfig
    */
    constructor(scope: Construct, id: string, config: AppKeyRegistrationConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
